<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Turing!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>
    <section>
        <title>Végtelen ciklus</title>
        <para>
            Írj olyan C végtelen ciklusokat, amelyek 0 illetve 100 százalékban dolgoztatnak egy magot és egy olyat, amely  
            100 százalékban minden magot!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/lvmi6tyz-nI">https://youtu.be/lvmi6tyz-nI</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="Turing/infty-f.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Turing/infty-f.c</filename>
            </link>, 
            <link xlink:href="Turing/infty-w.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Turing/infty-w.c</filename>
            </link>.
        </para>
        <para>
            Számos módon hozhatunk és hozunk létre végtelen ciklusokat. 
            Vannak esetek, amikor ez a célunk, például egy szerverfolyamat fusson folyamatosan és van amikor egy
            bug, mert ott lesz végtelen ciklus, ahol nem akartunk. Saját péláinkban ilyen amikor a PageRank algoritmus
            rázza az 1 liter vizet az internetben, de az iteráció csak nem akar konvergálni...
        </para>
	    <para>
	    Végtelen ciklust használnak például játékok és szolgáltatások is, amikor a "Press any key/Enter/stb. to continue"
	    üzenetet írják ki nekünk. Ekkor a háttérben egy végtelen ciklus fut, ami majd csak a megadott esemény
	    megtörténtekor lép ki a ciklusból.
	    </para>                    
        <para>
            Egy mag 100 százalékban: Ehhez egy végtelen ciklust használhatunk, ami teljes mértékben dolgoztatja a processzort. Két példa rá:
        </para>
        <programlisting language="c"><![CDATA[int
main ()
{
  for (;;); //nincs kilépési paraméter, így végtelen ciklus

  return 0;
}
]]>
        </programlisting>        
        <para>        
            Illetve a <literal>for</literal> helyett a könnyebben olvasható, de a fordítók (szabványok) között kevésbé hordozható <literal>while</literal>
	    használatával:
        </para>
        <programlisting language="c"><![CDATA[int
#include <stdbool.h>
main ()
{
  while(true); //a feltétel mindig igaz, így végtelen ciklus

  return 0;
}
]]>
        </programlisting>        
        <para>
            Azért érdemes a hagyományosabb <literal>for(;;)</literal> változatot használni, 
            mert ez minden C szabvánnyal lefordul, másrészt könnyebben látható, hogy szándékos a végtelen ciklus
            használata, és nem elírás vagy szoftverhiba. Mivel ha a <literal>while</literal>-t egy nem 
			triviális <literal>1</literal> vagy <literal>true</literal> feltétellel használjuk, akkor ott egy másik, a forrást
            olvasó programozó nem feltétlenül látja azonnal a szándékunkat.
        </para>
	<para>
	    A végtelen ciklusokra általában igaz, hogy 
	</para>            
        <para>
            Egyébként a fordító a <literal>for</literal>-os és 
            <literal>while</literal>-os ciklusból ugyanazt az assembly kódot fordítja:
        </para>            
        <screen><![CDATA[$ gcc -S -o infty-f.S infty-f.c 
$ gcc -S -o infty-w.S infty-w.c 
$ diff infty-w.S infty-f.S 
1c1
< 	.file	"infty-w.c"
---
> 	.file	"infty-f.c"
]]></screen>  
        <para>
            Egy mag 0 százalékban:               
        </para>        
        <programlisting language="c"><![CDATA[#include <unistd.h>
int
main ()
{
  for (;;)
    sleep(1); //1 másodpercig pihenteti a magot.
    
  return 0;
}
]]>
        </programlisting>        
        <para>
            Minden mag 100 százalékban:               
        </para>

        <programlisting language="c"><![CDATA[#include <omp.h>
int
main ()
{
#pragma omp parallel //Ez kell ahhoz, hogy párhuzamosan futhasson több magon.
{                    //Fordításnál ki kell egészíteni az "-fopenmp"-vel.
  for (;;);
}
  return 0;
}
]]>
        </programlisting>        
        <para>
            A <command>gcc infty-f.c -o infty-f -fopenmp</command> parancssorral készítve a futtathatót, majd futtatva,               
            közben egy másik terminálban a <command>top</command> parancsot kiadva tanulmányozzuk, mennyi CPU-t használunk:            
        </para>
        <screen><![CDATA[top - 20:09:06 up  3:35,  1 user,  load average: 5,68, 2,91, 1,38
Tasks: 329 total,   2 running, 256 sleeping,   0 stopped,   1 zombie
%Cpu0 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu1 : 99,7 us, 0,3 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu2 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu3 : 99,7 us, 0,3 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu4 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu5 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu6 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu7 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
KiB Mem :16373532 total,11701240 free, 2254256 used, 2418036 buff/cache
KiB Swap:16724988 total,16724988 free,       0 used. 13751608 avail Mem 

  PID USER      PR  NI    VIRT    RES    SHR S  %CPU %MEM     TIME+ COMMAND     
 5850 batfai    20   0   68360    932    836 R 798,3  0,0   8:14.23 infty-f     
]]></screen>  
                                
        <tip>
            <title>Werkfilm</title>
            <itemizedlist>
                <listitem>
                    <para>
                        <link xlink:href="https://youtu.be/lvmi6tyz-nI">https://youtu.be/lvmi6tyz-nI</link>
                    </para>    
                </listitem>                
            </itemizedlist>                
        </tip>
    </section>        
        
    <section>
        <title>Lefagyott, nem fagyott, akkor most mi van?</title>
        <para>
            Mutasd meg, hogy nem lehet olyan programot írni, amely bármely más programról eldönti, hogy le fog-e fagyni vagy sem!
        </para>
        <para>
            Megoldás forrása:  tegyük fel, hogy akkora haxorok vagyunk, hogy meg tudjuk írni a <function>Lefagy</function>
            függvényt, amely tetszőleges programról el tudja dönteni, hogy van-e benne végtelen ciklus:              
        </para>
        <programlisting language="c"><![CDATA[Program T100
{

	boolean Lefagy(Program P)
	{
		 if(P-ben van végtelen ciklus)
			return true;
		 else
			return false; 
	}

	main(Input Q)
	{
		Lefagy(Q)
	}
}]]></programlisting>            
        <para>
            A program futtatása, például akár az előző <filename>v.c</filename> ilyen pszeudókódjára:
            <screen><![CDATA[T100(t.c.pseudo)
true]]></screen>            
            akár önmagára
            <screen><![CDATA[T100(T100)
false]]></screen>  
            ezt a kimenetet adja.          
        </para>
        <para>
            A T100-as programot felhasználva készítsük most el az alábbi T1000-set, amelyben a
            Lefagy-ra épülő Lefagy2 már nem tartalmaz feltételezett, csak konkrét kódot:
        </para>
        <programlisting language="c"><![CDATA[Program T1000
{

	boolean Lefagy(Program P)
	{
		 if(P-ben van végtelen ciklus)
			return true;
		 else
			return false; 
	}

	boolean Lefagy2(Program P)
	{
		 if(Lefagy(P))
			return true;
		 else
			for(;;); 
	}

	main(Input Q)
	{
		Lefagy2(Q)
	}

}]]></programlisting>            
        <programlisting><![CDATA[]]></programlisting>            
        <para>
            Mit fog kiírni erre a <computeroutput>T1000(T1000)</computeroutput> futtatásra?
                                
            <itemizedlist>
                <listitem>
                    <para>Ha T1000 lefagyó, akkor nem fog lefagyni, kiírja, hogy true</para>                        
                </listitem>
                <listitem>
                    <para>Ha T1000 nem fagyó, akkor pedig le fog fagyni...</para>                        
                </listitem>
            </itemizedlist>
            akkor most hogy fog működni? Sehogy, mert ilyen <function>Lefagy</function>
            függvény, azaz a T100 program nem is létezik.                
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat: Ellentmondásba ütközik a program, bármerre is megy: Ha önmagára futtatjuk,
	    akkor teljesül az if ág, mivel végtelen ciklust tartalmaz, azaz lefagyó, és true értéket ad. Ez viszont nem lehetséges
	    mivel ha lefagyott volna, akkor nem adhatott volna vissza true értéket. A másik esetben nem teljesül az if ág, azaz a
	    program úgy véli, hogy nincs benne végtelen ciklus, ezért az else ágat végrehajtva végtelen ciklust kreál, azaz a
	    program le fog fagyni. Ez egy újabb ellentmondás, mivel az elején nem teljesült az if ág (nem volt benne végtelen ciklus)
	    most pedig van, azaz rossz értéket kaptunk vissza, mivel a program ténylegesen lefagyó volt.
        </para>
    </section>        
                
    <section>
        <title>Változók értékének felcserélése</title>
        <para>
            Írj olyan C programot, amely felcseréli két változó értékét, bármiféle logikai utasítás vagy kifejezés
            nasználata nélkül!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://bhaxor.blog.hu/2018/08/28/10_begin_goto_20_avagy_elindulunk">https://bhaxor.blog.hu/2018/08/28/10_begin_goto_20_avagy_elindulunk</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="Turing/valtcsere.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Turing/valtcsere.c</filename>
            </link>
        </para>
        <programlisting language="c"><![CDATA[#include <stdio.h>
int main()
{

    int a = 3;
    int b = 8;

    printf("a = %d, b = %d \n", a, b);

    a += b;
    b = a - b;
    a -= b;

    printf("a = %d, b = %d \n", a, b);
}
]]>
        </programlisting>
        <para>
            Tanulságok, tapasztalatok, magyarázat: Amennyiben lehetne használni egy c változót "köztes tároló"-ként, akkor ennek az értékét tennénk egyenlővé az a-val,
			majd az a értékét a b-vel, végül a b értékét c-vel. Mivel ezt nem tehetjük meg, ezért műveleteket kell használni. Az egyik változó a két érték összege lesz (a = 3 + 8),
			a másik változó az összeg és önmaga különbsége (b = 11 - 8), majd az első változó az összeg és a másik változó különbsége (a = 11 - 3).
        </para>
    </section>                     

    <section>
        <title>Labdapattogás</title>
        <para>
            Először if-ekkel, majd bármiféle logikai utasítás vagy kifejezés
            nasználata nélkül írj egy olyan programot, ami egy labdát pattogtat a karakteres konzolon! (Hogy mit értek
            pattogtatás alatt, alább láthatod a videókon.)
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://bhaxor.blog.hu/2018/08/28/labdapattogas">https://bhaxor.blog.hu/2018/08/28/labdapattogas</link>
        </para>
        <para>
            Megoldás: (if-fel) 
        </para>
	 <programlisting language="c"><![CDATA[#include <stdio.h>
#include <curses.h>
#include <unistd.h>

int main (void)
{
    WINDOW *ablak; 
    ablak = initscr (); 

    int x = 0; //behozzuk a három pár változót
    int y = 0; //a jelenlegi pozíció

    int deltax = 1; //a lépésköz
    int deltay = 1;

    int windowx; 
    int windowy;

    for (;;) {

        getmaxyx (ablak, windowy , windowx); //eltároljuk a "játéktér" dimenzióit, ami itt az ablak nagysága
        mvprintw (y, x, "O"); //kiírja a labdát
        refresh (); //lefrissíti a játékteret, hogy ténylegesen kiíródjon a labda
        usleep (100000); //a léptetés gyakorisága
        clear(); //letörli a játékteret

        x += deltax; //a labda léptetése
        y += deltay;
	
	//ha eléri a határokat megfordítják a lépésirányt
        if (x >= windowx-1) { //jobb határ
            deltax = deltax * -1;
        }
        if (x <= 0) { //bal határ
            deltax = deltax * -1;
        }
        if (y <= 0) { //felső határ
            deltay = deltay * -1;
        }
        if (y >= windowy-1) { //alsó határ
            deltay = deltay * -1;
        }

    }

    return 0;
}
]]>
        </programlisting>
	<para>
            Megoldás: (if nélkül: switch-el, még ha a switch nem is különbözik megvalósításban az if-től, formailag mások.) 
        </para>
	 <programlisting language="c"><![CDATA[#include <stdio.h>
#include <curses.h>
#include <unistd.h>

int main (void)
{
    WINDOW *ablak; 
    ablak = initscr (); 

    int x = 0; //behozzuk a három pár változót
    int y = 0; //a jelenlegi pozíció

    int deltax = 1; //a lépésköz
    int deltay = 1;

    int windowx; 
    int windowy;

    for (;;) {

        getmaxyx (ablak, windowy , windowx); //eltároljuk a "játéktér" dimenzióit, ami itt az ablak nagysága
        mvprintw (y, x, "O"); //kiírja a labdát
        refresh (); //lefrissíti a játékteret, hogy ténylegesen kiíródjon a labda
        usleep (100000); //a léptetés gyakorisága
        clear(); //letörli a játékteret

        x += deltax; //a labda léptetése
        y += deltay;
	
	//ha eléri a határokat megfordítják a lépésirányt
        
	switch(x>=windowx-1 || x<=0) //oldalhatár
	case true:
            deltax = deltax * -1;

	switch(y>=windowy-1 || y<=0) //felső- és alsóhatár
	case true:
            deltay = deltay * -1;
    }

    return 0;
}
]]>
        </programlisting>
		<para>
			Megoldás (if nélkül, és trükközés nélkül.)
        </para>
               <programlisting language="c"><![CDATA[#include <stdio.h>
#include <stdlib.h>
#include <curses.h>
#include <unistd.h>

int main ()
{
	WINDOW *ablak;
	ablak = initscr();
	
	int xj=0;
	int xk=0;
	int yj=0;
	int yk=0;
	
	int mx;
	int my;
	
	nodelay(ablak, true);
	getmaxyx(ablak,my,mx);
	
	my=my*2;
	mx=mx*2;

	for(;;)
	{
		xj = (xj-1)%mx;
		xk = (xk+1)%mx;
		yj = (yj-1)%my;
		yk = (yk+1)%my;
		clear();
		mvprintw(abs((yj+(my-yk)) / 2),abs((xj+(mx-xk)) / 2), "O");
		refresh();
		usleep(100000);
	}
	return 0;
}]]></programlisting> 
		<para>
            Utóbbi esetben az <literal>if</literal> állításokat leszámítva közel azonos lesz a kódunk. Mivel nem ellenőrizhetjük az
			ablak szélének elérését (túllépését) az előző módon, a maradékos osztást kell segítségül hívni. Egy számot n-nel
			osztva n-1 féle maradékot kaphatunk, ezzel a tulajdonsággal pedig egy "-tól-ig" határt szabhatunk a labda pattogásának,
			tehát ez esetben sem fogja túllépni a terminálablak méretét.
        </para>
        <para>
            Mindhárom esetben fordítás előtt szükséges telepíteni a curses.h header-t illetve utána a fordításnál használni
			az -lncurses kapcsolót. Ez szükséges ugyanis ahhoz, hogy a terminált grafikus felületként használhassuk.
        </para>
    </section>                     

    <section>
        <title>Szóhossz és a Linus Torvalds féle BogoMIPS</title>
        <para>
            Írj egy programot, ami megnézi, hogy hány bites a szó a gépeden, azaz mekkora az <type>int</type> mérete.
            Használd ugyanazt a while ciklus fejet, amit Linus Torvalds a BogoMIPS rutinjában! 
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/9KnMqrkj_kU">https://youtu.be/9KnMqrkj_kU</link>, 
            <link xlink:href="https://youtu.be/KRZlt1ZJ3qk">https://youtu.be/KRZlt1ZJ3qk</link>.
        </para>
        <para>
            Megoldás forrása: <link xlink:href="Turing/szohossz.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Turing/szohossz.c</filename>
            </link>
        </para>
        <programlisting language="c"><![CDATA[#include <stdio.h>

int main(void)
{
	unsigned int szo = 1;
	int bit = 1;

	while(szo <<= 1)
	{
		bit++;
	}

	printf("Szó mérete: %d\n", bit);
	return 0;
}
]]>
        </programlisting>
        <para>
            Tanulságok, tapasztalatok, magyarázat: Az 1 kettes számrendszerben 00000001. A &lt;&lt; operátor ezt az egyest tolja
			balra, így lesz 00000010. Megnézzük, hogy hány kör után tolódik az 1-es a változón kívülre, azaz a változóban már
			csupa 0 lesz, tehát a ciklus feltétele hamis lesz. Ahány kört ment +1 bites az int.
        </para>
    </section>                     

    <section>
        <title>Helló, Google!</title>
        <para>
            Írj olyan C programot, amely egy 4 honlapból álló hálózatra kiszámolja a négy lap Page-Rank 
            értékét!
        </para>
        <para>
            Megoldás forrása: <link xlink:href="Turing/pagerank.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Turing/pagerank.c</filename>
            </link>
        </para>
	<programlisting language="c"><![CDATA[#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void kiir (double tomb[], int db) {
	for (int i=0; i<db; i++) {
		printf("PR%d: %lf\n", i, tomb[i]);
	}
}

double tav (double PR[], double PRv[], int n) {
	double osszeg = 0;
	for (int i = 0; i < n; i++)
		osszeg += (PRv[i] - PR[i]) * (PRv[i] - PR[i]);
		sqrt(osszeg);
	return osszeg;
}

int main(void) {
	double L[4][4] = {
	  {0.0, 0.0, 1.0 / 3.0, 0.0},
	  {1.0, 1.0 / 2.0, 1.0 / 3.0, 1.0},
	  {0.0, 1.0 / 2.0, 0.0, 0.0},
	  {0.0, 0.0, 1.0 / 3.0, 0.0}
	};
	
	double PR[4]={0.0, 0.0, 0.0, 0.0};
	double PRv[4]={1.0 / 4.0, 1.0 / 4.0, 1.0 / 4.0, 1.0 / 4.0};

	int i = 0;
	int j = 0;

	for (;;) {
		for (i=0; i<4; i++) {
			PR[i] = 0.0;
			for (j=0;j<4;j++) {
				PR[i] += (L[i][j] * PRv[j]);
			}
		}

		if (tav(PR, PRv, 4) < 0.00001)
			break;

		for (i=0; i<4; i++) {
			PRv[i]=PR[i];
		}
	}

	kiir (PR, 4);

	return 0;
}
]]>
	</programlisting>
        <para>
            A PageRank a Google algoritmusa 1998-ból, ami a weboldalakat rangsorolja hasznosságuk szerint. Minél magasabb
			PageRank értékű oldal mutat egy másikra, annál magasabb lesz annak PageRank értéke.
		</para>
		<para>
			A számolása pontosságtól függően változó	számú iterációkból áll. Egy oldal PageRank értéke (1/n)-ről indul, ahol
			<literal>n</literal> az összes weboldal száma. A következő iterációkban a vizsgálandó oldalra mutató oldalak előző
			iterációbeli PageRank értékeit vesszük külön-külön és elosztjuk őket a belőlük kiinduló linkek számával, majd a
			kapott értékeket összeadva megkapjuk a végeredményt.
		</para>
		<para>
			A kiszámolt PageRank értékek közül értelemszerűen a legmagasabb lesz a "legértékesebb" oldal.
        </para>
		<para>
            Fordításnál szükséges a "-lm" kapcsoló a math header miatt.
        </para>
    </section>
                                                                                                                                                                                                                                                                                                                                                        
    <section xml:id="bhax-textbook-feladatok-turing.MontyHall">
        <title>A Monty Hall probléma</title>
        <para>
            Írj R szimulációt a Monty Hall problémára!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://bhaxor.blog.hu/2019/01/03/erdos_pal_mit_keresett_a_nagykonyvben_a_monty_hall-paradoxon_kapcsan">https://bhaxor.blog.hu/2019/01/03/erdos_pal_mit_keresett_a_nagykonyvben_a_monty_hall-paradoxon_kapcsan</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/MontyHall_R">https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/MontyHall_R</link>
        </para>
	<programlisting language="r"><![CDATA[#   An illustration written in R for the Monty Hall Problem 
#   Copyright (C) 2019  Dr. Norbert Bátfai, nbatfai@gmail.com
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>
#
#   https://bhaxor.blog.hu/2019/01/03/erdos_pal_mit_keresett_a_nagykonyvben_a_monty_hall-paradoxon_kapcsan
# 

kiserletek_szama=10000 # triviális
kiserlet = sample(1:3, kiserletek_szama, replace=T) # Mind a 10000 esethez
# hozzárendel egy választást az 1,2,3 számokból, ami ismétlődhet.
jatekos = sample(1:3, kiserletek_szama, replace=T) # Mind a 10000 esethez
# hozzárendel egy választást az 1,2,3 számokból, ami ismétlődhet.
musorvezeto=vector(length = kiserletek_szama) # A mérete ugyanúgy a
# kiserletek_szama-val lesz egyenlő, de nem random feltöltéssel:

# Itt azt szimuláljuk, hogy a műsorvezető tudja a kisérlet és a játékos
# értékét, és ezek tudatában fog kinyitni egy ajtót.
for (i in 1:kiserletek_szama) {

    if(kiserlet[i]==jatekos[i]){ # Itt a játékos eltalálta a jó ajtót.
    
        mibol=setdiff(c(1,2,3), kiserlet[i]) # Ezért elég az egyiket
        # kivenni, a kettő közül bármelyiket kinyithatja.
    
    }else{ # Itt a játékos nem találta el a jó ajtót.
    
        mibol=setdiff(c(1,2,3), c(kiserlet[i], jatekos[i])) # Ezért a három
        # esetből ki kell venni a jó ajtót és a játékos által választottat is.
    
    }

    musorvezeto[i] = mibol[sample(1:length(mibol),1)] # Itt "választ".

}

nemvaltoztatesnyer= which(kiserlet==jatekos) # Ha a játékos eltalálta és nem
# változtat, akkor nyer.
valtoztat=vector(length = kiserletek_szama) # Egy új vektor, a mérete ugyanúgy
# a kiserletek_szama-val lesz egyenlő

for (i in 1:kiserletek_szama) {

    holvalt = setdiff(c(1,2,3), c(musorvezeto[i], jatekos[i])) # Ha változtat,
    # akkor azt nyilván csak a még nem választottra teheti, ezért kell kivenni
    # a műsorvezető és a játékos által választottakat.
    valtoztat[i] = holvalt[sample(1:length(holvalt),1)]
    
}

valtoztatesnyer = which(kiserlet==valtoztat) # Ahhoz, hogy változtatás után
# nyerhessen, az új választásnak a nyereménnyel kell azonosnak lennie.

#kiiratások
sprintf("Kiserletek szama: %i", kiserletek_szama)
length(nemvaltoztatesnyer)
length(valtoztatesnyer)
length(nemvaltoztatesnyer)/length(valtoztatesnyer)
length(nemvaltoztatesnyer)+length(valtoztatesnyer)

]]>
	</programlisting>
        <para>
            A Monty Hall probléma: Monty Hall műsorvezető, a "Lets make a deal" nevű műsorban 3 ajtót kínál fel a játékosnak.
			Kettő mögött kecske, egy mögött pedig autó lapul. A játékosnak rá kell mutatnia arra az ajtóra, amelyik mögött szerintünk
			az autó van.	Ekkor Monty kinyitja a másik két ajtó közül az egyiket, amelyik mögött biztosan kecske van.
			Maradt tehát 2 ajtó, az egyik mögött a kecske, a másik mögött az autó. Ezután lehetőségünk van megváltoztatni a
			döntésünket, és a másik ajtót választani, vagy maradhatunk az eredeti választásnál.
		</para>
		<para>
			A józan ész azt diktálná, hogy minden, hogy változtatunk vagy sem, hiszen úgyis 50% esélyünk van rá, hogy eltaláljuk.
			Itt jön a matematika, ami látszólag szembe megy a józan ésszel, ugyanis az eredeti ajtó nyerési esélye 1 a 3-hoz,
			míg a másiké 2 a 3-hoz.
        </para>
    </section>

    <section xml:id="Brun">
        <title>100 éves a Brun tétel</title>
        <para>
            Írj R szimulációt a Brun tétel demonstrálására!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/xbYhp9G6VqQ">https://youtu.be/xbYhp9G6VqQ</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/nbatfai/bhax/blob/master/attention_raising/Primek_R">https://gitlab.com/nbatfai/bhax/blob/master/attention_raising/Primek_R</link>
        </para>

        <para>
            A természetes számok építőelemei a prímszámok. Abban az értelemben, 
            hogy minden természetes szám előállítható prímszámok szorzataként.
            Például 12=2*2*3, vagy például 33=3*11.
        </para>
        <para>
            Prímszám az a természetes szám, amely csak önmagával és eggyel 
            osztható. Eukleidész görög matematikus már Krisztus előtt tudta, 
            hogy végtelen sok prímszám van, de ma sem tudja senki, hogy 
            végtelen sok ikerprím van-e. Két prím ikerprím, ha különbségük 2.
        </para>
        <para>
            Két egymást követő páratlan prím között a legkisebb távolság a 2, 
            a legnagyobb távolság viszont bármilyen nagy lehet! Ez utóbbit 
            könnyű bebizonyítani. Legyen n egy tetszőlegesen nagy szám. 
            Akkor szorozzuk össze n+1-ig a számokat, azaz számoljuk ki az 
            1*2*3*… *(n-1)*n*(n+1) szorzatot, aminek a neve (n+1) faktoriális, 
            jele (n+1)!.
        </para>
        <para>
            Majd vizsgáljuk meg az a sorozatot:
        </para>    
        <para>
            (n+1)!+2, (n+1)!+3,… , (n+1)!+n, (n+1)!+ (n+1) ez n db egymást követő azám, ezekre (a jól ismert
            bizonyítás szerint) rendre igaz, hogy            
        </para>    
        <itemizedlist>
            <listitem>
                <para>(n+1)!+2=1*2*3*… *(n-1)*n*(n+1)+2, azaz 2*valamennyi+2, 2 többszöröse, így ami osztható kettővel</para>
            </listitem>
            <listitem>
                <para>(n+1)!+3=1*2*3*… *(n-1)*n*(n+1)+3, azaz 3*valamennyi+3, ami osztható hárommal</para>
            </listitem>
            <listitem>
                <para>...</para>
            </listitem>
            <listitem>
                <para>(n+1)!+(n-1)=1*2*3*… *(n-1)*n*(n+1)+(n-1), azaz (n-1)*valamennyi+(n-1), ami osztható (n-1)-el</para>
            </listitem>
            <listitem>
                <para>(n+1)!+n=1*2*3*… *(n-1)*n*(n+1)+n, azaz n*valamennyi+n-, ami osztható n-el</para>
            </listitem>
            <listitem>
                <para>(n+1)!+(n+1)=1*2*3*… *(n-1)*n*(n+1)+(n-1), azaz (n+1)*valamennyi+(n+1), ami osztható (n+1)-el</para>
            </listitem>
        </itemizedlist>
        <para>
            tehát ebben a sorozatban egy prim nincs, akkor a (n+1)!+2-nél 
            kisebb első prim és a (n+1)!+ (n+1)-nél nagyobb első 
            prim között a távolság legalább n.            
        </para>    
        <para>
            Az ikerprímszám sejtés azzal foglalkozik, amikor a prímek közötti 
            távolság 2. Azt mondja, hogy az egymástól 2 távolságra lévő prímek
            végtelen sokan vannak.
        </para>    
        <para>
            A Brun tétel azt mondja, hogy az ikerprímszámok reciprokaiból képzett sor összege, azaz
            a (1/3+1/5)+ (1/5+1/7)+ (1/11+1/13)+... véges vagy végtelen sor konvergens, ami azt jelenti, hogy ezek
            a törtek összeadva egy határt adnak ki pontosan vagy azt át nem lépve növekednek, 
            ami határ számot B<subscript>2</subscript> Brun konstansnak neveznek. Tehát ez
            nem dönti el a több ezer éve nyitott kérdést, hogy az ikerprímszámok halmaza végtelen-e? 
            Hiszen ha véges sok van és ezek
            reciprokait összeadjuk, akkor ugyanúgy nem lépjük át a B<subscript>2</subscript> Brun konstans értékét, 
            mintha végtelen 
            sok lenne, de ezek már csak olyan csökkenő mértékben járulnának hozzá a végtelen sor összegéhez, 
            hogy így sem lépnék át a Brun konstans értékét.     
        </para>
	<para>
	    A továbbiakban Bátfai Tanár Úr kiválóan elmagyarázza a kódot. Annyival egészíteném ki, hogy az olvasó ne
	    járjon úgy, mint én: Futtatás előtt ne felejtse el telepíteni a matlab packaget az 'install.packages("matlab")'
	    paranccsal. (A parancsot egy R ablakban kell beírni.)
	</para>
        <para>
            Ebben a példában egy olyan programot készítettünk, amely közelíteni próbálja a Brun konstans értékét.
            A repó <link xlink:href="../../../bhax/attention_raising/Primek_R/stp.r">
                <filename>bhax/attention_raising/Primek_R/stp.r</filename>
            </link> mevű állománya kiszámolja az ikerprímeket, összegzi
            a reciprokaikat és vizualizálja a kapott részeredményt.
        </para>
        <programlisting language="R">
<![CDATA[#   Copyright (C) 2019  Dr. Norbert Bátfai, nbatfai@gmail.com
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>

library(matlab)

stp <- function(x){

    primes = primes(x)
    diff = primes[2:length(primes)]-primes[1:length(primes)-1]
    idx = which(diff==2)
    t1primes = primes[idx]
    t2primes = primes[idx]+2
    rt1plust2 = 1/t1primes+1/t2primes
    return(sum(rt1plust2))
}

x=seq(13, 1000000, by=10000)
y=sapply(x, FUN = stp)
plot(x,y,type="b")
]]>
        </programlisting>        
        <para>
            Soronként értelemezzük ezt a programot:
        </para>                
        <programlisting language="R">
<![CDATA[ primes = primes(13)]]>
        </programlisting>        
        <para>
            Kiszámolja a megadott számig a prímeket.             
        </para>
        <screen>
<![CDATA[> primes=primes(13)
> primes
[1]  2  3  5  7 11 13
]]>
        </screen>
                
        <programlisting language="R">
<![CDATA[ diff = primes[2:length(primes)]-primes[1:length(primes)-1]]]>
        </programlisting>        
        <screen>
<![CDATA[> diff = primes[2:length(primes)]-primes[1:length(primes)-1]
> diff
[1] 1 2 2 4 2
]]>
        </screen>        
        <para>
            Az egymást követő prímek különbségét képzi, tehát 3-2, 5-3, 7-5, 11-7, 13-11.
        </para>
        <programlisting language="R">
<![CDATA[idx = which(diff==2)]]>
        </programlisting>        
        <screen>
<![CDATA[> idx = which(diff==2)
> idx
[1] 2 3 5
]]>
        </screen>              
        <para>
            Megnézi a <varname>diff</varname>-ben, hogy melyiknél lett kettő az eredmény, mert azok az ikerprím párok, ahol ez igaz.
            Ez a <varname>diff</varname>-ben lévő 3-2, 5-3, 7-5, 11-7, 13-11 különbségek közül ez a 2., 3. és 5. indexűre teljesül.
        </para>
        <programlisting language="R">
<![CDATA[t1primes = primes[idx]]]>
        </programlisting>  
        <para>
            Kivette a primes-ból a párok első tagját. 
        </para>
        <programlisting language="R">
<![CDATA[t2primes = primes[idx]+2]]>
        </programlisting>        
        <para>
            A párok második tagját az első tagok kettő hozzáadásával képezzük.
        </para>
        <programlisting language="R">
<![CDATA[rt1plust2 = 1/t1primes+1/t2primes]]>
        </programlisting>        
        <para>
            Az 1/t1primes a t1primes 3,5,11 értékéből az alábbi reciprokokat képzi:
        </para>
        <screen>
<![CDATA[> 1/t1primes
[1] 0.33333333 0.20000000 0.09090909
]]>
        </screen>                      
        <para>
            Az 1/t2primes a t2primes 5,7,13 értékéből az alábbi reciprokokat képzi:
        </para>
        <screen>
<![CDATA[> 1/t2primes
[1] 0.20000000 0.14285714 0.07692308
]]>
        </screen>                      
        <para>
            Az 1/t1primes + 1/t2primes pedig ezeket a törteket rendre összeadja.
        </para>
        <screen>
<![CDATA[> 1/t1primes+1/t2primes
[1] 0.5333333 0.3428571 0.1678322
]]>
        </screen>                      
        <para>
            Nincs más dolgunk, mint ezeket a törteket összeadni a 
            <function>sum</function> függvénnyel.
        </para>
        
        <programlisting language="R">
<![CDATA[sum(rt1plust2)]]>
        </programlisting>    
        <screen>
<![CDATA[>   sum(rt1plust2)
[1] 1.044023
]]>
        </screen>            
        <para>
            A következő ábra azt mutatja, hogy a szumma értéke, hogyan nő, egy határértékhez tart, a 
            B<subscript>2</subscript> Brun konstanshoz. Ezt ezzel a csipettel rajzoltuk ki, ahol először a fenti 
            számítást 13-ig végezzük, majd 10013, majd 20013-ig, egészen 990013-ig, azaz közel 1 millióig.
            Vegyük észre, hogy az ábra első köre, a 13 értékhez tartozó 1.044023.
        </para>
        <programlisting language="R">
<![CDATA[x=seq(13, 1000000, by=10000)
y=sapply(x, FUN = stp)
plot(x,y,type="b")]]>
        </programlisting>          
        <figure>
            <title>A B<subscript>2</subscript> konstans közelítése</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/BrunKorok.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>A B<subscript>2</subscript> konstans közelítése</phrase>
                </textobject>
            </mediaobject>
        </figure>                             
        <tip>
            <title>Werkfilm</title>
            <itemizedlist>
                <listitem>
                    <para>
                        <link xlink:href="https://youtu.be/VkMFrgBhN1g">https://youtu.be/VkMFrgBhN1g</link>
                    </para>    
                </listitem>                
                <listitem>
                    <para>
                        <link xlink:href="https://youtu.be/aF4YK6mBwf4">https://youtu.be/aF4YK6mBwf4</link>
                    </para>    
                </listitem>                
            </itemizedlist>                
        </tip>
    </section>
	
    <section>
        <title>Vörös Pipacs Pokol/csiga (folytonos mozgási parancsokkal)</title>
        <para>
            Írj olyan Minecraft MALMÖ python programot, amivel Steve csigavonalban járja be a pályát a folytonos mozgási parancsok felhasználásával.
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása: <link xlink:href="Turing/csiga_folytonos.py">
            	<filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Turing/csiga_folytonos.py</filename>
            </link>, <link xlink:href="http://hackers.inf.unideb.hu:443/RedFlowerHell/">http://hackers.inf.unideb.hu:443/RedFlowerHell/</link>
        </para>
        <para>
            Steve a négyszögletű pálya mind a négy oldalát bejárja "ut" időegység alatt, illetve fordul 90 fokot,
			ha elérte a az oldal szélét. Minden negyedik ilyen bejárás után ugrik egyet a következő szintre, és növeljük az
			"ut" változó értékét, hiszen felfelé haladva nő az út hossza. Ezt a folyamatot Steve a lávában való elégésig ismétli.
        </para>
		<programlisting language="python"><![CDATA[from __future__ import print_function
# ------------------------------------------------------------------------------------------------
# Copyright (c) 2016 Microsoft Corporation
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
# associated documentation files (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge, publish, distribute,
# sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in all copies or
# substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
# NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
# ------------------------------------------------------------------------------------------------

# Tutorial sample #2: Run simple mission using raw XML

# Added modifications by Norbert Bátfai (nb4tf4i) batfai.norbert@inf.unideb.hu, mine.ly/nb4tf4i.1
# 2018.10.18, https://bhaxor.blog.hu/2018/10/18/malmo_minecraft
# 2020.02.02, NB4tf4i's Red Flowers, http://smartcity.inf.unideb.hu/~norbi/NB4tf4iRedFlowerHell


from builtins import range
import MalmoPython
import os
import sys
import time
import random
import json
import math

if sys.version_info[0] == 2:
    sys.stdout = os.fdopen(sys.stdout.fileno(), 'w', 0)  # flush print output immediately
else:
    import functools
    print = functools.partial(print, flush=True)

# Create default Malmo objects:

agent_host = MalmoPython.AgentHost()
try:
    agent_host.parse( sys.argv )
except RuntimeError as e:
    print('ERROR:',e)
    print(agent_host.getUsage())
    exit(1)
if agent_host.receivedArgument("help"):
    print(agent_host.getUsage())
    exit(0)

# -- set up the mission -- #
missionXML_file='nb4tf4i.xml'
with open(missionXML_file, 'r') as f:
    print("NB4tf4i's Red Flowers (Red Flower Hell) - DEAC-Hackers Battle Royale Arena\n")
    print("NB4tf4i vörös pipacsai (Vörös Pipacs Pokol) - DEAC-Hackers Battle Royale Arena\n\n")
    print("The aim of this first challenge, called nb4tf4i's red flowers, is to collect as many red flowers as possible before the lava flows down the hillside.\n")
    print("Ennek az első, az nb4tf4i vörös virágai nevű kihívásnak a célja összegyűjteni annyi piros virágot, amennyit csak lehet, mielőtt a láva lefolyik a hegyoldalon.\n")    
    print("Norbert Bátfai, batfai.norbert@inf.unideb.hu, https://arato.inf.unideb.hu/batfai.norbert/\n\n")    
    print("Loading mission from %s" % missionXML_file)
    mission_xml = f.read()
    my_mission = MalmoPython.MissionSpec(mission_xml, True)
    my_mission.drawBlock( 0, 0, 0, "lava")


class Hourglass:
    def __init__(self, charSet):
        self.charSet = charSet
        self.index = 0
    def cursor(self):
        self.index=(self.index+1)%len(self.charSet)
        return self.charSet[self.index]

hg = Hourglass('|/-\|')

class Steve:
    def __init__(self, agent_host):
        self.agent_host = agent_host
        
        self.nof_red_flower = 0

    def run(self):
        world_state = self.agent_host.getWorldState()
        ut = 2
        # Loop until mission ends:
        while world_state.is_mission_running:
            print("--- nb4tf4i arena -----------------------------------\n")
            self.agent_host.sendCommand( "move 1" )
            time.sleep(ut)            
            self.agent_host.sendCommand( "turn 1" )
            time.sleep(.5)
            self.agent_host.sendCommand( "turn 0" )
            self.agent_host.sendCommand( "move 1" )
            time.sleep(ut)            
            self.agent_host.sendCommand( "turn 1" )
            time.sleep(.5)
            self.agent_host.sendCommand( "turn 0" )
            self.agent_host.sendCommand( "move 1" )
            time.sleep(ut)            
            self.agent_host.sendCommand( "turn 1" )
            time.sleep(.5)
            self.agent_host.sendCommand( "turn 0" )
            self.agent_host.sendCommand( "move 1" )
            time.sleep(ut)            
            self.agent_host.sendCommand( "jump 1" )
            time.sleep(.5)
            self.agent_host.sendCommand( "jump 0" )
            ut = ut + 2
            world_state = self.agent_host.getWorldState()

num_repeats = 1
for ii in range(num_repeats):

    my_mission_record = MalmoPython.MissionRecordSpec()

    # Attempt to start a mission:
    max_retries = 6
    for retry in range(max_retries):
        try:
            agent_host.startMission( my_mission, my_mission_record )
            break
        except RuntimeError as e:
            if retry == max_retries - 1:
                print("Error starting mission:", e)
                exit(1)
            else:
                print("Attempting to start the mission:")
                time.sleep(2)

    # Loop until mission starts:
    print("   Waiting for the mission to start ")
    world_state = agent_host.getWorldState()

    while not world_state.has_mission_begun:
        print("\r"+hg.cursor(), end="")
        time.sleep(0.15)
        world_state = agent_host.getWorldState()
        for error in world_state.errors:
            print("Error:",error.text)

    print("NB4tf4i Red Flower Hell running\n")
    steve = Steve(agent_host)
    steve.run()
    print("Number of flowers: "+ str(steve.nof_red_flower))

print("Mission ended")
# Mission has ended.
]]></programlisting>
	<para>
		A lényeg ebből a Steve osztály:
	</para>
        <programlisting language="python"><![CDATA[class Steve:
    def __init__(self, agent_host):
        self.agent_host = agent_host
        
        self.nof_red_flower = 0

    def run(self):
        world_state = self.agent_host.getWorldState()
        ut = 2
        # Loop until mission ends:
        while world_state.is_mission_running:
            print("--- nb4tf4i arena -----------------------------------\n")
            self.agent_host.sendCommand( "move 1" )
            time.sleep(ut)            
            self.agent_host.sendCommand( "turn 1" )
            time.sleep(.5)
            self.agent_host.sendCommand( "turn 0" )
            self.agent_host.sendCommand( "move 1" )
            time.sleep(ut)            
            self.agent_host.sendCommand( "turn 1" )
            time.sleep(.5)
            self.agent_host.sendCommand( "turn 0" )
            self.agent_host.sendCommand( "move 1" )
            time.sleep(ut)            
            self.agent_host.sendCommand( "turn 1" )
            time.sleep(.5)
            self.agent_host.sendCommand( "turn 0" )
            self.agent_host.sendCommand( "move 1" )
            time.sleep(ut)            
            self.agent_host.sendCommand( "jump 1" )
            time.sleep(.5)
            self.agent_host.sendCommand( "jump 0" )
            ut = ut + 2
            world_state = self.agent_host.getWorldState()
]]></programlisting> 
    </section> 
</chapter>    
